## cmock 2.5.3%2Bgit40-g379a9a8

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=none

override_dh_install:
	dh_install -X.gitattributes -X.gitignore -X.gitmodules
	chmod -v -x debian/cmock/usr/share/cmock/meson.build
	chmod -v -x debian/cmock/usr/share/cmock/vendor/unity/examples/example_4/subprojects/unity.wrap
