## cmock 2.5.3+git40-g379a9a8

=== debian/changelog ===
cmock (2.5.3+git40-g379a9a8-2) unstable; urgency=medium

  * Source-only upload.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 06 Feb 2024 00:24:27 +0100

cmock (2.5.3+git40-g379a9a8-1) unstable; urgency=medium

  * Initial release. (Previously bundled with src:khronos-opencl-clhpp.)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Jan 2024 23:31:22 +0100
