=== debian/control ===
Source: cmock
Section: devel
Priority: optional
Maintainer: Andreas Beckmann <anbe@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.2
Homepage: https://github.com/ThrowTheSwitch/CMock
Vcs-Browser: https://salsa.debian.org/debian/cmock
Vcs-Git: https://salsa.debian.org/debian/cmock.git

Package: cmock
Architecture: all
Multi-Arch: foreign
Depends:
 ruby:any,
 ${misc:Depends},
Description: mock and stub generator and runtime for unit testing C
 CMock is a mock and stub generator and runtime for unit testing C.
 It's been designed to work smoothly with Unity Test, another of the
 embedded-software testing tools developed by ThrowTheSwitch.org.
 CMock automagically parses your C headers and creates useful and usable
 mock interfaces for unit testing. Give it a try!
